<template>
	<div>
		<b-card title="Select a Master Course" class="pb-0 mb-0">
			<b-card-body class="p-0 mb-0">
				<div>
					<b-tabs
						content-class="mt-3"
						v-model="master_type"
						@input="onChange"
						card
					>
						<b-tab title="None">
							No course copy from another course.
						</b-tab>
						<b-tab title="Specific">
							Specify a course to copy from.
							<p>
								The ID of the course can be obtained by taking the number at the
								end of the URL when visiting a course. For example, the ID would
								be "7504" on the course URL:
								https://courses.maine.edu/d2l/home/7504. Upon entering a number,
								the title will appear below.
							</p>
							<CourseIdInput
								v-model="specified_course_id"
								lms_id="specific"
								type="courseCopy"
							/>
						</b-tab>
						<b-tab
							title="Select From Existing"
							v-if="hasPermission('get:university-all')"
						>
							Select a course to copy from.
							<div role="tablist">
								<b-card
									no-body
									class="mb-1"
									v-for="u in universities"
									v-bind:key="u.lms_id"
								>
									<b-card-header header-tag="header" class="p-1" role="tab">
										<b-button
											block
											href="#"
											v-b-toggle="'accord_uni_' + u.lms_id"
											variant="info"
											>{{ u.short_name }}</b-button
										>
									</b-card-header>
									<b-collapse
										:id="'accord_uni_' + u.lms_id"
										accordion="universities"
										role="tabpanel"
									>
										<b-card-body>
											<b-card-text class="p-1">{{ u.name }}</b-card-text>
											<b-container>
												<b-row align-v="center">
													<b-col>
														<CourseIdInput
															:value="u.template_lms_id_fall"
															:lms_id="u.lms_id"
															term="fall"
															:read_only="true"
														/>
													</b-col>
													<b-col>
														<b-button
															:variant="
																selected_course_id === u.template_lms_id_fall &&
																selected_course_term === 'Fall'
																	? 'success'
																	: 'primary'
															"
															@click.stop.prevent="
																select_course(
																	u.template_lms_id_fall,
																	u.short_name,
																	'Fall'
																)
															"
															:disabled="
																u.template_lms_id_fall &&
																	u.template_lms_id_fall.length === 0
															"
															>Select Fall</b-button
														>
													</b-col>
												</b-row>
											</b-container>
											<b-container>
												<b-row align-v="center">
													<b-col>
														<CourseIdInput
															:value="u.template_lms_id_spring"
															:lms_id="u.lms_id"
															term="spring"
															:read_only="true"
														/>
													</b-col>
													<b-col>
														<b-button
															:variant="
																selected_course_id ===
																	u.template_lms_id_spring &&
																selected_course_term === 'Spring'
																	? 'success'
																	: 'primary'
															"
															@click.stop.prevent="
																select_course(
																	u.template_lms_id_spring,
																	u.short_name,
																	'Spring'
																)
															"
															:disabled="
																u.template_lms_id_spring &&
																	u.template_lms_id_spring.length === 0
															"
															>Select Spring</b-button
														>
													</b-col>
												</b-row>
											</b-container>
											<b-container>
												<b-row align-v="center">
													<b-col>
														<CourseIdInput
															:value="u.template_lms_id_summer"
															:lms_id="u.lms_id"
															term="summer"
															:read_only="true"
														/>
													</b-col>
													<b-col>
														<b-button
															:variant="
																selected_course_id ===
																	u.template_lms_id_summer &&
																selected_course_term === 'Summer'
																	? 'success'
																	: 'primary'
															"
															@click.stop.prevent="
																select_course(
																	u.template_lms_id_summer,
																	u.short_name,
																	'Summer'
																)
															"
															:disabled="
																u.template_lms_id_summer &&
																	u.template_lms_id_summer.length === 0
															"
															>Select Summer</b-button
														>
													</b-col>
												</b-row>
											</b-container>
											<div
												class="px-4"
												v-show="colleges_filtered(u.lms_id).length > 0"
												v-if="hasPermission('get:college-set')"
											>
												<hr class="mt-3" />
												{{ u.short_name }} Colleges with a master course set:
												<b-card
													no-body
													class="mb-1"
													v-for="c in colleges_filtered(u.lms_id)"
													v-bind:key="c.lms_id"
												>
													<b-card-header
														header-tag="header"
														class="p-1"
														role="tab"
													>
														<b-button
															block
															href="#"
															v-b-toggle="'accord_col_' + c.lms_id"
															variant="dark"
															>{{ c.name }}</b-button
														>
													</b-card-header>
													<b-collapse
														:id="'accord_col_' + c.lms_id"
														:accordion="'colleges_' + c.lms_id"
														role="tabpanel"
													>
														<b-card-body>
															<b-card-text class="p-1">{{
																c.name
															}}</b-card-text>
															<b-container>
																<b-row align-v="center">
																	<b-col>
																		<CourseIdInput
																			:value="c.template_lms_id_fall"
																			:lms_id="c.lms_id"
																			term="fall"
																			:read_only="true"
																		/>
																	</b-col>
																	<b-col>
																		<b-button
																			:variant="
																				selected_course_id ===
																					c.template_lms_id_fall &&
																				selected_course_term === 'Fall'
																					? 'success'
																					: 'primary'
																			"
																			@click.stop.prevent="
																				select_course(
																					c.template_lms_id_fall,
																					u.short_name + ' / ' + c.name,
																					'Fall'
																				)
																			"
																			:disabled="
																				c.template_lms_id_fall &&
																					c.template_lms_id_fall.length === 0
																			"
																			>Select Fall</b-button
																		>
																	</b-col>
																</b-row>
															</b-container>
															<b-container>
																<b-row align-v="center">
																	<b-col>
																		<CourseIdInput
																			:value="c.template_lms_id_spring"
																			:lms_id="c.lms_id"
																			term="spring"
																			:read_only="true"
																		/>
																	</b-col>
																	<b-col>
																		<b-button
																			:variant="
																				selected_course_id ===
																					c.template_lms_id_spring &&
																				selected_course_term === 'Spring'
																					? 'success'
																					: 'primary'
																			"
																			@click.stop.prevent="
																				select_course(
																					c.template_lms_id_spring,
																					u.short_name + ' / ' + c.name,
																					'Spring'
																				)
																			"
																			:disabled="
																				c.template_lms_id_spring &&
																					c.template_lms_id_spring.length === 0
																			"
																			>Select Spring</b-button
																		>
																	</b-col>
																</b-row>
															</b-container>
															<b-container>
																<b-row align-v="center">
																	<b-col>
																		<CourseIdInput
																			:value="c.template_lms_id_summer"
																			:lms_id="c.lms_id"
																			term="summer"
																			:read_only="true"
																		/>
																	</b-col>
																	<b-col>
																		<b-button
																			:variant="
																				selected_course_id ===
																					c.template_lms_id_summer &&
																				selected_course_term === 'Summer'
																					? 'success'
																					: 'primary'
																			"
																			@click.stop.prevent="
																				select_course(
																					c.template_lms_id_summer,
																					u.short_name + ' / ' + c.name,
																					'Summer'
																				)
																			"
																			:disabled="
																				c.template_lms_id_summer &&
																					c.template_lms_id_summer.length === 0
																			"
																			>Select Summer</b-button
																		>
																	</b-col>
																</b-row>
															</b-container>
															<div
																class="px-4"
																v-show="
																	academic_units_filtered(c.lms_id).length > 0
																"
																v-if="hasPermission('get:academicUnit-set')"
															>
																<hr class="mt-3" />
																{{ c.name }} Academic Units with a master course
																set
																<b-card
																	no-body
																	class="mb-1"
																	v-for="au in academic_units_filtered(
																		c.lms_id
																	)"
																	v-bind:key="au.lms_id"
																>
																	<b-card-header
																		header-tag="header"
																		class="p-1"
																		role="tab"
																	>
																		<b-button
																			block
																			href="#"
																			v-b-toggle="'accord_au_' + au.lms_id"
																			variant="light"
																			>{{ au.name }}</b-button
																		>
																	</b-card-header>
																	<b-collapse
																		:id="'accord_au_' + au.lms_id"
																		:accordion="'acad_unit_' + au.lms_id"
																		role="tabpanel"
																	>
																		<b-card-body>
																			<b-card-text class="p-1">{{
																				au.name
																			}}</b-card-text>
																			<b-container>
																				<b-row align-v="center">
																					<b-col>
																						<CourseIdInput
																							:value="au.template_lms_id_fall"
																							:lms_id="au.lms_id"
																							term="fall"
																							:read_only="true"
																						/>
																					</b-col>
																					<b-col>
																						<b-button
																							:variant="
																								selected_course_id ===
																									au.template_lms_id_fall &&
																								selected_course_term === 'Fall'
																									? 'success'
																									: 'primary'
																							"
																							@click.stop.prevent="
																								select_course(
																									au.template_lms_id_fall,
																									u.short_name +
																										' / ' +
																										c.name +
																										' / ' +
																										au.name,
																									'Fall'
																								)
																							"
																							:disabled="
																								au.template_lms_id_fall &&
																									au.template_lms_id_fall
																										.length === 0
																							"
																							>Select Fall</b-button
																						>
																					</b-col>
																				</b-row>
																			</b-container>
																			<b-container>
																				<b-row align-v="center">
																					<b-col>
																						<CourseIdInput
																							:value="au.template_lms_id_spring"
																							:lms_id="au.lms_id"
																							term="spring"
																							:read_only="true"
																						/>
																					</b-col>
																					<b-col>
																						<b-button
																							:variant="
																								selected_course_id ===
																									au.template_lms_id_spring &&
																								selected_course_term ===
																									'Spring'
																									? 'success'
																									: 'primary'
																							"
																							@click.stop.prevent="
																								select_course(
																									au.template_lms_id_spring,
																									u.short_name +
																										' / ' +
																										c.name +
																										' / ' +
																										au.name,
																									'Spring'
																								)
																							"
																							:disabled="
																								au.template_lms_id_spring &&
																									au.template_lms_id_spring
																										.length === 0
																							"
																							>Select Spring</b-button
																						>
																					</b-col>
																				</b-row>
																			</b-container>
																			<b-container>
																				<b-row align-v="center">
																					<b-col>
																						<CourseIdInput
																							:value="au.template_lms_id_summer"
																							:lms_id="au.lms_id"
																							term="summer"
																							:read_only="true"
																						/>
																					</b-col>
																					<b-col>
																						<b-button
																							:variant="
																								selected_course_id ===
																									au.template_lms_id_summer &&
																								selected_course_term ===
																									'Summer'
																									? 'success'
																									: 'primary'
																							"
																							@click.stop.prevent="
																								select_course(
																									au.template_lms_id_summer,
																									u.short_name +
																										' / ' +
																										c.name +
																										' / ' +
																										au.name,
																									'Summer'
																								)
																							"
																							:disabled="
																								au.template_lms_id_summer &&
																									au.template_lms_id_summer
																										.length === 0
																							"
																							>Select Summer</b-button
																						>
																					</b-col>
																				</b-row>
																			</b-container>
																		</b-card-body>
																	</b-collapse>
																</b-card>
															</div>
														</b-card-body>
													</b-collapse>
												</b-card>
											</div>
										</b-card-body>
									</b-collapse>
								</b-card>
							</div>
							<div class="mt-3 mb-0">
								<strong>{{ selected_course_display }}</strong>
							</div>
						</b-tab>
					</b-tabs>
				</div>
			</b-card-body>
		</b-card>
	</div>
</template>

<script>
import { mapGetters, mapActions } from "vuex";

export default {
	props: ["value"],
	model: {
		prop: "value",
		event: "change"
	},
	data() {
		return {
			master_type: 0,
			specified_course_id: "",
			selected_course_id: "",
			selected_course_description: "",
			selected_course_term: ""
		};
	},
	computed: {
		...mapGetters({
      universities: "MasterCourseSelector/universities",
      colleges: "MasterCourseSelector/colleges",
      academic_units: "MasterCourseSelector/academic_units",
      hasPermission:"Navbar/hasPermission",
      showAdminHelpInfo: "Navbar/showAdminHelpInfo"
    }),
		selected_course_display() {
			if (this.selected_course_id === "") {
				return "";
			}

			return (
				"Selected: " +
				this.selected_course_description +
				" " +
				this.selected_course_term +
				" (" +
				this.selected_course_id +
				")"
			);
		}
	},
	methods: {
		...mapActions({get_universities: "MasterCourseSelector/get_universities"
      , get_colleges: "MasterCourseSelector/get_colleges", get_academic_units:"MasterCourseSelector/get_academic_units"}),
		select_course(template_lms_id, description, term) {
			this.selected_course_id = template_lms_id;
			this.selected_course_description = description;
			this.selected_course_term = term;
		},
		colleges_filtered(university_lms_id) {
			if (this.colleges === undefined) {
				return [];
			}

			return this.colleges.filter(function(c) {
				return c.parent === university_lms_id;
			});
		},
		academic_units_filtered(college_lms_id) {
			if (this.academic_units === undefined) {
				return [];
			}

			return this.academic_units.filter(function(au) {
				return au.parent === college_lms_id;
			});
		},
		onChange() {
			let id = null;
			if (this.master_type !== 0) {
				if (this.master_type === 1) {
					id = this.specified_course_id;
				} else if (this.master_type === 2) {
					id = this.selected_course_id;
				}
			}

			this.$emit("change", id);
		}
	},
	watch: {
		specified_course_id: function() {
			this.onChange();
		},
		selected_course_id: function() {
			this.onChange();
		}
	},
	mounted() {
		if (this.hasPermission("get:university-all")) {
			this.get_universities();
		}
		if (this.hasPermission("get:college-set")) {
			this.get_colleges();
		}
		if (this.hasPermission("get:academicUnit-set")) {
			this.get_academic_units();
		}
	}
};
</script>
